import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'custom_notification_method_channel.dart';

abstract class CustomNotificationPlatform extends PlatformInterface {
  /// Constructs a CustomNotificationPlatform.
  CustomNotificationPlatform() : super(token: _token);

  static final Object _token = Object();

  static CustomNotificationPlatform _instance =
      MethodChannelCustomNotification();

  /// The default instance of [CustomNotificationPlatform] to use.
  ///
  /// Defaults to [MethodChannelCustomNotification].
  static CustomNotificationPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [CustomNotificationPlatform] when
  /// they register themselves.
  static set instance(CustomNotificationPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<void> showRecordNotification(
      int notificationId, bool isRecording, String timeDesc,
      {required String channelId, required String channelName}) {
    throw UnimplementedError(
        'showRecordNotification() has not been implemented.');
  }

  Future<void> showAnalyseResultNotification(
      int notificationId, bool isSuccess, String talkId,
      {required String channelId, required String channelName}) {
    throw UnimplementedError(
        'showAnalyseResultNotification() has not been implemented.');
  }

  Stream<String> recordActionStream() {
    throw UnimplementedError('recordActionStream() has not been implemented.');
  }
}
